Subject: Re: [PATCH 1/2][RFC] vlan: use pskb_copy() when inserting a vlan tag by hand

From: Patrick McHardy <[email-masked]>
Date: Tue, 08 Jul 2008 18:24:44 +0200

Patrick McHardy wrote:
> Lennert Buytenhek wrote:
>> On Mon, Jul 07, 2008 at 11:01:18PM +0200, Patrick McHardy wrote:
>>
>>>> When inserting a vlan tag into an skb by hand (in the case the
>>>> target network device hardware does not support inserting a vlan
>>>> tag by passing it in via the TX descriptor), making a copy of the
>>>> skb to be modified by calling skb_copy() is overkill, since
>>>> skb_copy() will needlessly linearize the skb, copying of all of
>>>> the fragmented data around, and checksumming the paket in software
>>>> even if the hardware is perfectly capable of doing that by itself.
>>>>
>>>> For this case, pskb_copy() does exactly what is needed and no more,
>>>> so use that instead.
>>>>
>>>> Signed-off-by: Lennert Buytenhek <[email-masked]>
>>> This looks fine to me.
>>
>> OK.  Since the mv643xx_eth patch (2/2) depends on both this patch
>> and the one you/I sent previously, could you merge the mv643xx_eth
>> patch (2/2) via your tree as well?
>
>
> I already sent the network_header fix to Dave, so its probably
> easiest to have it go through him directly. Your patch applies
> cleanly on top of my VLAN update from this morning. 

Actually, are you sure this patch is helping for the case
you describe? The function you changed is only called on
the RX path.